/*
 * $Id: hash.h,v 1.1.1.1 2002/02/23 02:47:02 kos Exp $
 *
 */

/*
 * asciiz key for elems
 * linked list hanging off buckets
 */

#ifndef _HASH_H
#define _HASH_H

#define DEF_HASH_NBUCKETS 256
#define DEF_MODE_REPLACE 1

typedef struct bucket_t {
  struct bucket_t *next;
  struct bucket_t *prev;
  char *key;
  void *datap;
  unsigned int datal;
} bucket_t;

typedef struct {
  int nbuckets;  
  int *accesses;
  bucket_t **buckets;
  int mode_replace;
} hash_t;

hash_t *hash_new(int buckets);
void hash_destroy(hash_t *h);
int hash_add(hash_t *, char *key, void *b, unsigned int l);
int hash_get(hash_t *, char *key, void **b, unsigned int *l);
char *hash_key(hash_t *, unsigned int index);
void hash_dump(hash_t *h);
int hash_exists(hash_t *h, char *key);
int hash_nelem(hash_t *h);
int hash_index(hash_t *h, int index, char *p, int len);

#endif /* _HASH_H */
