/*
 * $Id: wifivendors.c,v 1.1.1.1 2002/02/23 02:47:02 kos Exp $
 *
 */

#include <string.h>

#include "wifivendors.h"

typedef struct vendor_maclist_t {
  unsigned char *mac_prefix;
  unsigned char *vendor;
} vendor_maclist_t;

static vendor_maclist_t vendor_maclist[] = {
  {"00:00:f0", "Samsung"},
  {"00:00:ff", "Camtec"},
  {"00:01:03", "3com"},
  {"00:01:f4", "Enterasys (Cabletron)"},
  {"00:02:2d", "Agere (Lucent) Orinoco"},
  {"00:02:6f", "Senao Intl"},
  {"00:02:78", "Samsung"},
  {"00:02:b3", "Intel"},
  {"00:03:2f", "GST (Linksys)"},
  {"00:04:25", "Atmel"},
  {"00:04:5a", "Linksys"},
  {"00:04:76", "3Com"},
  {"00:05:5d", "D-Link"},
  {"00:10:e7", "BreezeNet"},
  {"00:20:d8", "NetWave (Bay Networks)"},
  {"00:30:65", "Apple"},
  {"00:30:ab", "Delta Networks"},
  {"00:40:05", "D-Link"},
  {"00:40:33", "Addtron"},
  {"00:40:36", "Zoom (Tribe)"},
  {"00:40:96", "Cisco (Aironet)"},
  {"00:50:18", "Advanced Multimedia Internet"},
  {"00:50:8b", "Compaq"},
  {"00:50:da", "3Com"},
  {"00:60:1d", "Agere (Lucent) Wavom"},
  {"00:90:4b", "Gemtek (D-Link)"},
  {"00:90:d1", "Addtron"},
  {"00:a0:f8", "Symbol"},
  {"00:e0:03", "Nokia"},
  {"00:e0:29", "SMC"},
  {"00:e0:63", "Enterasys (Cabletron)"},
  {"08:00:02", "3Com"},
  {"08:00:46", "Sony"},
  {NULL, NULL}
};

unsigned char *
wifi_get_vendor(unsigned char *mac) {
  vendor_maclist_t *p;
  int i;

  for(i=0; vendor_maclist[i].vendor; i++) {
    p = &vendor_maclist[i];
    if(!strncmp(vendor_maclist[i].mac_prefix, mac, strlen(vendor_maclist[i].mac_prefix) -1 )) {
      return vendor_maclist[i].vendor;
    }
  }
  
  return "unknown";
}

