/*
 * $Id: xpaudio-oss.c,v 1.1.1.1 2002/02/23 02:47:02 kos Exp $
 *
 *
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/ioctl.h>


#ifdef HAVE_LINUX_SOUNDCARD_H
#include <linux/soundcard.h>
#endif

#include "xmalloc.h"
#include "xpaudio.h"

#define XPA_DEFAULTDEVICE "/dev/dsp"

xpaudio_t *
xpaudio_new(char *ud) {
  xpaudio_t *xpa;
  
  xpa = xcalloc(1, sizeof(xpaudio_t));
  if(ud)
    strncpy(xpa->device, ud, XPA_LINELEN);
  else
    strncpy(xpa->device, XPA_DEFAULTDEVICE, XPA_LINELEN);
  
  if((xpa->fd = open(xpa->device, O_WRONLY|O_NDELAY)) < 0) {
    free(xpa);
    return (xpaudio_t *)NULL;
  }

  return xpa;
}

int
xpaudio_destroy(xpaudio_t *xpa) {
  close(xpa->fd);
  xfree(xpa);
  return 0;
}

int
xpaudio_set(xpaudio_t *xpa, unsigned int param, int val) {
  int ret;

  switch(param) {
  case XPA_RATE:
    ret = ioctl(xpa->fd, SNDCTL_DSP_RATE, &val);
    xpa->rate = val;
    break;
  case XPA_NCHANNELS:
    ret = ioctl(xpa->fd, SNDCTL_DSP_CHANNELS, &val);
    xpa->channels = val;
    break;
  case XPA_ENCODING:
    ret = ioctl(xpa->fd, SNDCTL_DSP_SETFMT, &val);
    xpa->encoding = val;
    break;
  default:
    return -1;
  }
  
  return ret;
}

int 
xpaudio_get(xpaudio_t *xpa, unsigned int param) {
  
  switch(param) {
  case XPA_RATE:
    return(xpa->rate);
    break;
  case XPA_NCHANNELS:
    return(xpa->channels);
    break;
  case XPA_ENCODING:
    return(xpa->encoding);
    break;
  default:    
    return 1;
  }  
  return 0;
}

char *
xpaudio_describe(xpaudio_t *xpa) {
  return "OSS sound module";
}

int
xpaudio_send(xpaudio_t *xpa, unsigned char *data, unsigned int len) {
  int foo;

  write(xpa->fd, data, len);
  ioctl(xpa->fd, SNDCTL_DSP_SYNC, &foo);
  return 0;
}
