/*
 * $Id: xpaudio.h,v 1.1.1.1 2002/02/23 02:47:02 kos Exp $
 *
 */

#ifndef _XPAUDIO_H
#define _XPAUDIO_H

#define XPA_LINELEN 1024

#define XPA_RATE (1<<0)
#define XPA_ENCODING (1<<1)
#define XPA_NCHANNELS (1<<2)

#define XPA_ENCODING_LINEAR (1<<1)
#define XPA_ENCODING_ULAW (1<<2)
#define XPA_ENCODING_8BIT (1<<3)
#define XPA_ENCODING_16BIT (1<<4)
#define XPA_ENCODING_SIGNED (1<<5)
#define XPA_ENCODING_UNSIGNED (1<<6)

#define XPA_RATE_DEFAULT 44100
#define XPA_NCHANNELS_DEFAULT 2
#define XPA_ENCODING_DEFAULT (XPA_ENCODING_LINEAR|XPA_ENCODING_16BIT|XPA_ENCODING_UNSIGNED)

typedef struct xpaudio_t {
  int fd;
  int rate;
  int channels;
  int encoding;
  char device[XPA_LINELEN];
} xpaudio_t ;

xpaudio_t *xpaudio_new(char *dev);
int xpaudio_destroy(xpaudio_t *);
int xpaudio_set(xpaudio_t *xp, unsigned int param, int what);
int xpaudio_get(xpaudio_t *xp, unsigned int param);
int xpaudio_send(xpaudio_t *xp, unsigned char *sample, unsigned int samplen);
char *xpaudio_describe(xpaudio_t *xpa);

#endif /* _XPAUDIO_H */
